#include <iostream>
#include<vector>

using namespace std;

int main()
{
	int N;
	int Q;
	cin >> N >> Q;
	vector<int>dan(N);
	vector<int>brojPlazmi(N);
	int pojedenePlazme = 0;
	int kupljenePlazme = 0;
	vector<int>plazme;

	for (int i = 0; i < N; i++) {
		int x, y;
		cin >> x>> y;
		dan[i]=x;
		brojPlazmi[i]=y;
	}
	int x, y=0;
	int c = 0;


	for (int i = 0; i < Q; i++) {
		cin >> x;
		while (c < N - 1 && dan[c] <= x) {
			
				pojedenePlazme += brojPlazmi[c] - 1;
				y = c;
				c++;
				if (dan[c] <= x && c!=N-1) {
					pojedenePlazme = pojedenePlazme + brojPlazmi[c] - ((dan[c] - dan[y]) + 1);
				}else if (c == N - 1) {
					pojedenePlazme = pojedenePlazme + brojPlazmi[c] - ((x - dan[c]) + 1);
				}
				
				
				if (pojedenePlazme < 0)pojedenePlazme = 0;
	
		}

		plazme.push_back(pojedenePlazme);
	}
	for (int i = 0; i < Q; i++) {
		cout << plazme[i] << endl;
	}
}